local collider  = require 'HardonCollider';
local loader = require("TilesetLoader/Loader");
local map = loader.load("map.tmx");
local tileLayer = map.layers["Ground"];
local tutorial = {};
local player = {img = love.graphics.newImage('brick.png')};
local sData = {};
function colTrue(dt, objA, objB, x, y)
	if(objA == player.colRect) then
		objA:move(x, y)
		player.x = player.x + x;
		player.y = player.y + y;
	end
end

function love.load()
	player.width  = 32
	player.height = 40
	player.x      = 0
	player.y      = 0
	player.xSpeed = 0
	player.ySpeed = 0
	player.xAcc   = 300
	player.yAcc   = 300
	col = collider(100, colTrue)
	player.colRect = col:addRectangle(player.x, player.y, player.width, player.height)
	local i = 0
	for tilex, tiley, tile in tileLayer:iterate() do
      if tile.properties.colAll == 1 then
        ctile = col:addRectangle(tilex * 32, tiley * 32, 32, 32)
        col:addToGroup('tiles', ctile)
        col:setPassive(ctile)
        sData[#sData+1] = {x=tilex, y=tiley, tile=tile}
        i = i + 1
      end
   end
end

function love.update(dt)
	if(love.keyboard.isDown('a')) then
		player.xSpeed = -player.xAcc
	end
	if(love.keyboard.isDown('d')) then
		player.xSpeed = player.xAcc
	end
	if(love.keyboard.isDown('w')) then
		player.ySpeed = -player.yAcc
	end
	if(love.keyboard.isDown('s')) then
		player.ySpeed = player.yAcc
	end

	if not(love.keyboard.isDown('a') or love.keyboard.isDown('d')) then
		if(player.xSpeed ~= 0) then
			player.xSpeed = 0
		end
	end
	if not(love.keyboard.isDown('w') or love.keyboard.isDown('s')) then
		if(player.ySpeed ~= 0) then
			player.ySpeed = 0
		end
	end

	if(player.xSpeed ~= 0) then
		if(player.xSpeed > 0) then
			player.x = player.x + player.xSpeed * dt
		end
		if(player.xSpeed < 0) then
			player.x = player.x + player.xSpeed * dt
		end
	end
	if(player.ySpeed ~= 0) then
		if(player.ySpeed < 0) then
			player.y = player.y + player.ySpeed * dt
		end
		if(player.ySpeed > 0) then
			player.y = player.y + player.ySpeed * dt
		end
	end

	local rectX = player.x + player.width / 2
	local rectY = player.y + player.height / 2
	player.colRect:moveTo(rectX, rectY)
	col:update(dt)
end

function love.draw()
	love.graphics.push()
	love.graphics.translate(0, 0)
	map:draw()
	map:setDrawRange(0, 0, map.width * map.tileWidth, map.height * map.tileHeight)
	love.graphics.pop()
	player.colRect:draw('fill')
	love.graphics.setColor(255, 255, 255, 220)
end
